<?php

/**
 * Implementiert die beroCloud und SNMP Einstellungen
 * @author Miguel Palmer <mp@beronet.com>
 */
class RemoteManagement {

	/**
	 * Generiert die HTML Seite
	 * @return string HTML code
	 */
	function display() {
		$m = $_GET['m'];
		$name = "REMOTE_MANAGEMENT_TITLE_DIS";

		include('./includes/header.php');
		$remoteM_table = $this->dynamic_table();
		// build page content
		$ret .= $remoteM_table;

		return $ret;
	}

	/**
	 * @return string Checkbox cloud enable
	 */
	function cloud_enable() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$cloud_enable = $bc->get("root", "cloud_enable");
		$checked = ($cloud_enable == "1") ? "checked" : "";
		ob_start();
		?>
		<input type='hidden' name='cloud_enable' value='0'>
		<input type='checkbox' name='cloud_enable' id='cloud_enable' value='1' <? echo $checked ?>>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld Cloud Adresse
	 */
	function cloud_url() {
		$ba = new beroAri();
		$cloudAddress = $ba->get("cloudAddress");
		ob_start();
		?>
		<input type='text' class='form-control input-sm' name='cloudAddress' id='cloudAddress' value='<? echo $cloudAddress ?>'>
		<br>
		<input type='button' class='btn btn-default' value='<? echo BUTTON_LOAD_DEF ?>' onclick='load();'>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Checkbox Enable SNMP
	 */
	function snmp_enabled() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmp_enable = $bc->get("root", "snmp-enabled");
		$checked = ($snmp_enable == "1") ? "checked" : "";
		ob_start();
		?>
		<input type='hidden' name='snmp_enabled' value='0'>
		<input type='checkbox' id='snmp_enable' onchange='snmp_show();' name='snmp_enabled' value='1' <? echo $checked ?>>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld SNMP Syslocation
	 */
	function snmp_syslocation() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmp_syslocation = $bc->get('root', 'snmp-syslocation');
		ob_start();
		?>
		<input type="text" class="form-control input-sm" name="snmp_syslocation" value="<? echo $snmp_syslocation ?>" maxlength="255" >
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Checkbox Enable SNMP traps
	 */
	function snmptraps() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps = $bc->get("root", "snmptraps");
		$snmptraps = explode(",", $snmptraps);
		$checked = (in_array("snmptrap_isdnl2", $snmptraps)) ? "checked" : "";
		ob_start();
		?>
		<input type='checkbox' name='snmptraps' value='snmptrap_isdnl2' <? echo $checked ?>> ISDN-Layer 2
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld SNMP traps sink
	 */
	function snmptraps_sink() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps_sink = $bc->get("root", "snmptraps_sink");
		ob_start();
		?>
		<input type='text' class='form-control input-sm' name='snmptraps_sink' value='<? echo $snmptraps_sink ?>'>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld SNMP traps intervall
	 */
	function snmptraps_intervall() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$snmptraps_intervall = $bc->get("root", "snmptraps_intervall");
		ob_start();
		?>
		<input type='text' class='form-control input-sm' name='snmptraps_intervall' value='<? echo $snmptraps_intervall ?>'>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld SNMP community ro
	 */
	function ro_community() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$ro_community = $bc->get("root", "snmp-community-ro");
		ob_start();
		?>
		<input type='text' class='form-control input-sm' name='snmp_community_ro' value='<? echo $ro_community ?>'>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld SNMP community rw
	 */
	function rw_community() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$rw_community = $bc->get("root", "snmp-community-rw");
		ob_start();
		?>
		<input type='text' class='form-control input-sm' name='snmp_community_rw' value='<? echo $rw_community ?>'>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Textfeld SNMP community trap
	 */
	function community_trap() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$community_trap = $bc->get("root", "snmp-community-trap");
		ob_start();
		?>
		<input type='text' class='form-control input-sm' name='snmp_community_trap' value='<? echo $community_trap ?>'>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Checkbox cloud proxy enable
	 */
	function proxy_enable() {
		$ba = new beroAri();
		$proxy_enable = $ba->get("proxyEnabled");

		$checked = ($proxy_enable == "1") ? "checked" : "";
		ob_start();
		?>
		<input type='hidden' name='proxyEnabled' value='0'>
		<input type='checkbox' name='proxyEnabled' id='proxyEnabled' value='1' <? echo $checked ?>>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string Cloud key
	 */
	function cloud_key() {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		return $bc->get("root", "cloud_key");
	}

	/**
	 * 
	 * @return string Dropdown cloud proxy type
	 */
	function proxy_type() {
		$ba = new beroAri();
		$proxyType = $ba->get("proxyType");
		$selectedHttp = ($proxyType == "CURLPROXY_HTTP") ? "selected" : "";
		$selectedSocks5 = ($proxyType == "CURLPROXY_SOCKS5") ? "selected" : "";
		ob_start();
		?>
		<select class='form-control input-sm' name='proxyType'>
			<option value='CURLPROXY_HTTP' <? echo $selectedHttp ?>>HTTP</option>
			<option value='CURLPROXY_SOCKS5' <? echo $selectedSocks5 ?>>SOCKS5</option>
		</select>
		<?php
		return ob_get_clean();
	}

	/**
	 * Check, if a valid url is provided
	 * @param string $url
	 * @return boolean
	 */
	function isDomainAvailable($url) {
		$connected = @fsockopen($url, 443); //website and port
		if ($connected) {
			$is_conn = true; //action when connected
			fclose($connected);
		} else {
			$is_conn = false; //action in connection failure
		}
		return $is_conn;
	}

	/**
	 * Generates the javascript code
	 * @return string
	 */
	function javascript() {
		ob_start();
		?>
		<script type="text/javascript">
		    $(document).ready(function () {
		        snmp_show();
		    });
		    function load() {
		        $('#cloudAddress').val('berocloud.beronet.com');
		    }
		    function snmp_show() {
		        if ($('#snmp_enable').is(':checked')) {
		            $('#traps').show();
		            $('#sink').show();
		            $('#interval').show();
		            $('#communityRo').show();
		            $('#communityRw').show();
		            $('#communityTrap').show();
		        } else {
		            $('#traps').hide();
		            $('#sink').hide();
		            $('#interval').hide();
		            $('#communityRo').hide();
		            $('#communityRw').hide();
		            $('#communityTrap').hide();
		        }
		    }
		    $('#cloud').validate({
		        rules: {
		            cloudAddress: {
		                checkHostname: true,
		                required: '#cloud_enable:checked',
		            },
		        }
		    });
		    $('#support').validate({
		        rules: {
		            supportKey: {
		                required: true,
		                minlength: 8,
		                maxlength: 8,
		            },
		        }
		    });
		    $('#proxy').validate({
		        rules: {
		            proxyAddress: {
		                required: '#proxyEnabled:checked',
		            },
		            proxyPort: {
		                required: '#proxyEnabled:checked',
		                digits: true,
		                range: [1, 65535],
		            },
		        }
		    });

		    $('#snmp').validate({
		        rules: {
		            snmptraps_intervall: {
		                required: true,
		                digits: true,
		            },
		            snmp_community_ro: {
		                checkSnmp: true
		            },
		            snmp_community_rw: {
		                checkSnmp: true
		            },
		            snmp_community_trap: {
		                checkSnmp: true
		            },
		        }
		    });
		    $('#proxyEnabled').change(function () {
		        required();
		    });
		    $('#cloud_enable').change(function () {
		        required();
		    });
		    function required() {
		        if ($('#proxyEnabled').is(':checked')) {
		            addAsterisk('proxyAddress');
		            addAsterisk('proxyPort');
		        } else {
		            deleteAsterisk('proxyAddress');
		            deleteAsterisk('proxyPort');
		        }
		        if ($('#cloud_enable').is(':checked')) {
		            addAsterisk('cloudAddress');
		        } else {
		            deleteAsterisk('cloudAddress');
		        }
		    }
		    required();
		</script>
		<?php
		return ob_get_clean();
	}

	/**
	 * Generates the form for the cloud registration
	 * @return string HTML code
	 */
	function cloudRegisterTable() {
		ob_start();
		?>
		<p class="text-center lead"><? echo CLOUD_TABLE_HEADER_DIS ?></p>
		<form  class='form-horizontal' action='' method='POST' autocomplete='off'>
			<input name='fixChrome' type='password' style='display:none'>
			<input type=hidden name=m value="<? echo $_GET['m'] ?>">
			<div class="form-group">
				<label for='cloud_username' class='col-sm-5 control-label'>Cloud username</label>
				<div class='col-sm-4'>
					<input type='text' class='form-control input-sm' name='cloud_username'>
				</div>
			</div>
			<div class="form-group">
				<label for='cloud_password' class='col-sm-5 control-label'>Cloud password</label>
				<div class='col-sm-4'>
					<input type='password' class='form-control input-sm' autocomplete='new-password' name='cloud_password'>
				</div>
			</div>
			<div class="text-center" data-toggle='tooltip' title='<? echo CLOUD_NETWORK_HINT ?>'>
				<input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_REGISTER ?>'>
			</div>
		</form>
		<br>
		<br>
		<form name='support' id='support' action='' class="form-horizontal" method='POST'>
			<div class="form-group">
				<label for='supportKey' class='col-sm-5 control-label'><? echo CLOUD_SUPPORT_KEY_DIS ?></label>
				<div class='col-sm-4'>
					<input type="text" name="supportKey" class='form-control input-sm'>
				</div>
			</div>
			<div class="text-center">
				<input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_CONNECT ?>'>
			</div>
			<br>
		</form>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string HTML form for the general cloud settings
	 */
	function cloudTable() {
		ob_start();
		?>
		<form name='cloud' id='cloud' action='' class="form-horizontal" method='POST'>
			<div class="form-group">
				<label for='cloud_enable' class='col-sm-5 control-label'><? echo CLOUD_ENABLE_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->cloud_enable() ?>
				</div>
			</div>
			<div class="form-group">
				<label for='cloudAddress' class='col-sm-5 control-label'><? echo CLOUD_URL_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->cloud_url() ?>
				</div>
			</div>
			<br>
			<div class="text-center">
				<input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_SAVE ?>'>&nbsp;
				<input name='deregister' class='btn btn-default' type='submit' value='<? echo BUTTON_DEREGISTER ?>' 
					   onclick='return confirm("<? echo CLOUD_MESSAGE_DIS ?>?");'>
			</div>
			<br>
		</form>
		<?php
		return ob_get_clean();
	}

	/**
	 * @param beroAri $ba
	 * @param string $simple_class
	 * @return string HTML form für the cloud proxy settings
	 */
	function cloudProxyTable($ba, $simple_class = null) {
		ob_start();
		?>
		<div class="<? echo $simple_class ?>">
			<br>
			<br>
			<form name='proxy' id='proxy' action='' class="form-horizontal" method='POST'>

				<p class="text-center lead"><? echo CLOUD_PROXY_SETTINGS ?></p>
				<div class="form-group">
					<label for='proxyEnabled' class='col-sm-5 control-label'><? echo CLOUD_PROXY_ENABLE ?></label>
					<div class='col-sm-4'>
						<? echo $this->proxy_enable() ?>
					</div>
				</div>
				<div class="form-group">
					<label for='proxyAddress' class='col-sm-5 control-label'><? echo CLOUD_PROXY_ADDRESS ?></label>
					<div class='col-sm-4'>
						<input type='text' class='form-control input-sm' name='proxyAddress' value='<? echo $ba->get('proxyAddress') ?>'>
					</div>
				</div>
				<div class="form-group">
					<label for='proxyPort' class='col-sm-5 control-label'><? echo CLOUD_PROXY_PORT ?></label>
					<div class='col-sm-4'>
						<input type='text' class='form-control input-sm' name='proxyPort' value='<? echo $ba->get('proxyPort') ?>'>
					</div>
				</div>
				<div class="form-group">
					<label for='proxyType' class='col-sm-5 control-label'><? echo CLOUD_PROXY_TYPE ?></label>
					<div class='col-sm-4'>
						<? echo $this->proxy_type() ?>
					</div>
				</div>
				<div class="form-group">
					<label for='proxyUser' class='col-sm-5 control-label'><? echo CLOUD_PROXY_USER ?></label>
					<div class='col-sm-4'>
						<input type='text' class='form-control input-sm' name='proxyUser' value='<? echo $ba->get('proxyUser') ?>'>
					</div>
				</div>
				<div class="form-group">
					<label for='proxySecret' class='col-sm-5 control-label'><? echo CLOUD_PROXY_SECRET ?></label>
					<div class='col-sm-4'>
						<input type='password' class='form-control input-sm' name='proxySecret'  value='<? echo $ba->get('proxySecret') ?>'>
					</div>
				</div>
				<div class="text-center">
					<input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_SAVE ?>'>
				</div>
				<br>
			</form>
		</div>
		<?php
		return ob_get_clean();
	}

	/**
	 * Generates the html form for the SNMP settings
	 * @param string $simple_class
	 * @return string HTML form
	 */
	function snmpTable($simple_class = null) {
		ob_start();
		?>
		<div class="<? echo $simple_class ?>">
			<br>
			<br>
			<form id='snmp' action='' method='POST' class="form-horizontal">
				<p class="text-center lead"><? echo SNMP_TABLE_HEADER_DIS ?></p>
				<input type=hidden name=m value="<? echo $_GET['m'] ?>">
				<div class="form-group">
					<label for='snmp_enabled' class='col-sm-5 control-label'><? echo SNMP_ENABLED_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->snmp_enabled() ?>
					</div>
				</div>
				<div class="form-group" id='snmp_syslocation'>
					<label for='snmp_syslocation' class='col-sm-5 control-label'><? echo SNMP_SYSLOCATION ?></label>
					<div class='col-sm-4'>
						<? echo $this->snmp_syslocation() ?>
					</div>
				</div>
				<div class="form-group" id='traps'>
					<label for='snmptraps' class='col-sm-5 control-label'><? echo SNMP_TRAPS_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->snmptraps() ?>
					</div>
				</div>
				<div class="form-group" id='sink'>
					<label for='snmptraps_sink' class='col-sm-5 control-label'><? echo SNMP_TRAPS_SINK_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->snmptraps_sink() ?>
					</div>
				</div>
				<div class="form-group" id='interval'>
					<label for='snmptraps_intervall' class='col-sm-5 control-label'><? echo SNMP_TRAPS_INTERVALL_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->snmptraps_intervall() ?>
					</div>
				</div>
				<div class="form-group" id='communityRo'>
					<label for='snmp_community_ro' class='col-sm-5 control-label'><? echo SNMP_RO_COMMUNITY_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->ro_community() ?>
					</div>
				</div>
				<div class="form-group" id='communityRw'>
					<label for='snmp_community_rw' class='col-sm-5 control-label'><? echo SNMP_RW_COMMUNITY_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->rw_community() ?>
					</div>
				</div>
				<div class="form-group" id='communityTrap'>
					<label for='snmp_community_trap' class='col-sm-5 control-label'><? echo SNMP_COMMUNITY_TRAP_DIS ?></label>
					<div class='col-sm-4'>
						<? echo $this->community_trap() ?>
					</div>
				</div>
				<? if (is_file("/usr/local/conf/BEROFIX-MIB.txt")): ?>
					<div class="text-center" >
						<a href=\"misc/files_download.php?option=BEROFIX-MIB\">Download BEROFIX-MIB</a>
					</div>
				<? endif; ?>
				<br>			<div class="text-center" >
					<input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_SAVE ?>'>
				</div>
			</form>
		</div>
		<?php
		return ob_get_clean();
	}

	/**
	 * Saves the setting in the database
	 * @param beroAri $ba
	 * @return string HTML code
	 */
	function save($ba) {
		require_once( '/usr/fallback/beroConf.php' );
		$bc = new beroConf('root');
		$result = "";
		$serial = Helper::getSerial();
		if (isset($_POST['deregister'])) {
			$apiUrl = 'https://' . $ba->get("cloudAddress") . '/index.php?r=api/deregister';
			$ch = curl_init();

			$data = array('serial' => $serial, 'key' => $bc->get('root', 'cloud_key'));

			curl_setopt($ch, CURLOPT_URL, $apiUrl);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

			$result = curl_exec($ch);

			curl_close($ch);
			if ($result != "" && trim($result) == "Device was deregistered") {
				$bc->set('root', 'cloud_enable', 0);
				$bc->set('root', 'cloud_key', '');
				$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
				$table .= "<div class='text-center'><img src='./includes/images/punkt_gruen.gif'><font color='black'>" . $result . "<br/></div>";
			} elseif ($result != "")
				$table .= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . $result . "</font><br/></div>";
		}elseif (isset($_POST['cloud_enable'])) {
			$bc->set('root', 'cloud_enable', sqlite_escape_string($_POST['cloud_enable']));
			$ba->set("cloudAddress", sqlite_escape_string(trim($_POST['cloudAddress'])));

			if (isset($_POST['cloud_key']))
				$bc->set('root', 'cloud_key', sqlite_escape_string($_POST['cloud_key']));


			$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
		}
		if (isset($_POST['snmp_enabled'])) {
			$bc->set('root', 'snmp-enabled', $_POST['snmp_enabled']);
			if ($_POST['snmp_enabled'] == 1) {
				$bc->set('root', 'snmptraps', sqlite_escape_string($_POST['snmptraps']));
				$bc->set('root', 'snmp-syslocation', sqlite_escape_string($_POST['snmp_syslocation']));
				$bc->set('root', 'snmptraps_sink', sqlite_escape_string($_POST['snmptraps_sink']));
				$bc->set('root', 'snmptraps_intervall', sqlite_escape_string($_POST['snmptraps_intervall']));
				$bc->set('root', 'snmp-community-rw', sqlite_escape_string($_POST['snmp_community_rw']));
				$bc->set('root', 'snmp-community-ro', sqlite_escape_string($_POST['snmp_community_ro']));
				$bc->set('root', 'snmp-community-trap', sqlite_escape_string($_POST['snmp_community_trap']));
			} else {
				$bc->set('root', 'snmptraps', "");
				$bc->set('root', 'snmp-syslocation', '');
				$bc->set('root', 'snmptraps_sink', "");
				$bc->set('root', 'snmptraps_intervall', "");
				$bc->set('root', 'snmp-community-rw', "");
				$bc->set('root', 'snmp-community-ro', "");
				$bc->set('root', 'snmp-community-trap', "");
			}

			$table .= Helper::activate(2, true, $_GET['m'], ACTIVATE);
		}
		if ($_POST['proxyEnabled'] == '1' && isset($_POST['proxyAddress']) && isset($_POST['proxyPort']) && isset($_POST['proxyType'])) {
			$ba->set('proxyEnabled', sqlite_escape_string($_POST['proxyEnabled']));
			$ba->set('proxyAddress', sqlite_escape_string($_POST['proxyAddress']));
			$ba->set('proxyPort', sqlite_escape_string($_POST['proxyPort']));
			$ba->set('proxyType', sqlite_escape_string($_POST['proxyType']));
			$ba->set('proxyUser', sqlite_escape_string($_POST['proxyUser']));
			$ba->set('proxySecret', sqlite_escape_string($_POST['proxySecret']));
			$ba = new beroAri();
			$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
		} else if ($_POST['proxyEnabled'] == '0') {
			$ba->set('proxyEnabled', 0);
			$ba->set('proxyAddress', "");
			$ba->set('proxyPort', "");
			$ba->set('proxyType', "");
			$ba->set('proxyUser', "");
			$ba->set('proxySecret', "");
			$ba = new beroAri();
			$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
		}
		if (isset($_POST['cloud_username']) && isset($_POST['cloud_password'])) {
			$apiUrl = 'https://' . $ba->get("cloudAddress") . '/index.php?r=api/register';
			if (($bc->get('root', 'lan-nameserver') == "" || $bc->get('root', 'lan-gateway') == "") && $bc->get('root', 'lan-gateway') == "no")
				$result = CLOUD_NETWORK_HINT;
			else if (!$this->isDomainAvailable($ba->get("cloudAddress")))
				$result = CLOUD_NO_CONNECTION_HINT;
			else {
				$ch = curl_init();

				$data = array('serial' => $serial, 'cloud_username' => $_POST['cloud_username'], 'cloud_password' => $_POST['cloud_password']);

				curl_setopt($ch, CURLOPT_URL, $apiUrl);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

				$result = curl_exec($ch);
				preg_match("/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/", $result, $key);
				$key = unserialize($key['key']);
				if (isset($key['key'])) {
					$bc->set('root', 'cloud_key', $key['key']);
					$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
					$result = preg_replace("/[^a-zA-Z0-9=]*?yaqwsx(?<key>.+)yaqwsx/", ". ", $result);
				}
				curl_close($ch);
			}
			if ($result != "" && strpos($result, "Device was registered"))
				$table .= "<div class='text-center'><img src='./includes/images/punkt_gruen.gif'><font color='black'>" . $result . "<br/></div>";
			elseif ($result != "" && !strpos($result, "Device was registered"))
				$table .= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . $result . "</font><br/></div>";
		}
		
		//Remote access for support
		if (isset($_POST['supportKey'])) {
			$apiUrl = 'https://' . $ba->get("cloudAddress") . '/index.php?r=api/support-access&key=' 
				. $_POST['supportKey'] . '&serial=' . $serial;
			if (($bc->get('root', 'lan-nameserver') == "" || $bc->get('root', 'lan-gateway') == "") && $bc->get('root', 'lan-gateway') == "no") {
				$table .= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . CLOUD_NETWORK_HINT . "</font><br/></div>";
			} else if (!$this->isDomainAvailable($ba->get("cloudAddress"))) {
				$table .= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . CLOUD_NO_CONNECTION_HINT . "</font><br/></div>";
			} else {
				$ch = curl_init();


				curl_setopt($ch, CURLOPT_URL, $apiUrl);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
				if (! $result = curl_exec($ch)) {
					$table.= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . curl_error($ch) . "</font><br/></div>";
				}
				curl_close($ch);
				if ($result != "" && trim($result)== "Invalid data") {
					$table .= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . $result . "</font><br/></div>";
				} else {
					$result = unserialize($result);
					
					if (isset($result['sshKey']) && isset($result['sysCmd'])) {
						file_put_contents('/tmp/key', $result['sshKey']);
						chmod('/tmp/key', 0600);

						exec('/sbin/' . $result['sysCmd']);
						$table .= "<div class='text-center'><img src='./includes/images/punkt_gruen.gif'><font color='black'>Remote tunnel success<br/></div>";
					}else{
						$table .= "<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>Invalid request</font><br/></div>";
					}
				}
			}
		}

		return $table;
	}

	function dynamic_table() {
		$ba = new beroAri();
		require_once( '/usr/fallback/beroConf.php' );
		require_once("./includes/lang.php");
		//Save the changes
		if ($ba->get('gui_mode') == 'simple') {
			$simple_class = 'simple';
		}
		$table .= $this->save($ba);

		$table .= $this->cloudRegisterTable();
		$table .= "<br><br>";
		$table .= $this->cloudTable();
		$table .= $this->cloudProxyTable($ba, $simple_class);
		$table .= $this->snmpTable($simple_class);
		$table .= "<br>"
			. "<div class='text-center'>"
			. "<i>" . REQUIRED_FIELDS . "</i>"
			. "</div>";
		$table .= $this->javascript();

		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
?>
